module Main where

import Data.Serialize.Put (runPut, putWord8)
import qualified Data.Text.Lazy as TL
import Network.Lean.Lai
import Network.Lean.Lai.Handler.Larp (LarpApplication, run)
import Network.Lean.Types

import qualified Data.Serialize.Ldsf.Lean.Category.Text.V0 as TextV0
import Data.Serialize.Ldsf.Types

main :: IO ()
main = run 8080 app

app :: LarpApplication
app request respond = do
    putStrLn "Client request:"
    print request
    
    case requestCategory request of
         Browser ->
             respond $ Response
             { responseType = Ok
             , responsePayload = [ValueNothing]
             , responseInternal = Nothing
             }
         Text    -> respond $ Response
             { responseType = Ok
             , responsePayload = [ValueText32 $ TL.pack "Hello, world!"]
             , responseInternal = Nothing
             }
         _       -> respond $ Response
             { responseType = ServerError
             , responsePayload = [ValueNothing]
             , responseInternal = Nothing
             }
